﻿@model OperationalRiskException.Core.ViewModels.QuestionCategoryVM
@{
    ViewBag.Title = "Question Categories";
}


<div class="row">
    <div class="col-md-12 grid-margin">
        <div class="d-flex justify-content-between flex-wrap">
            <div class="d-flex align-items-end flex-wrap">
                <div class="d-flex">
                    <i class="mdi mdi-home text-muted hover-cursor"></i>
                    <p class="text-muted mb-0 hover-cursor">&nbsp;/&nbsp; Upload Management &nbsp;/&nbsp;</p>
                    <p class="text-primary mb-0 hover-cursor">Categories</p>
                </div>
            </div>

        </div>
    </div>
</div>

<div class="row">
    <div class="col-md-12 grid-margin stretch-card">
        <div class="card">
            <div class="card-body">
                <h4 class="card-title"> Upload </h4>
                <p class="card-description">
                    Create Upload Category
                </p>

                @using (Html.BeginForm("QCategoryPage", "Question", FormMethod.Post, new { @class = "forms-sample", role = "form" }))
                {
                    @Html.AntiForgeryToken()

                    <div class="row">
                        <div class="form-group col-md-12">
                            <label for="exampleInputUsername1">Category Name</label>
                            <div class="row col-md-12">
                                @Html.EditorFor(n => n.CategoriesName, new { htmlAttributes = new { @class = "form-control", @placeholder = "Category Name" } })
                                @Html.ValidationMessageFor(model => model.CategoriesName, null, new { @class = "text text-danger" })
                            </div>
                        </div>

                        
                    </div>



                    <button type="submit" class="btn btn-primary mr-2">Add Upload Category</button>
                }
            </div>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-md-12 grid-margin stretch-card">
        <div class="card tablecontainer">
            <div class="card-body">
                <h4 class="card-title"></h4>
                <p class="card-description">
                    List of Upload Categories
                </p>
                <div class="table-responsive pt-3">
                    <table class="table table-bordered" id="myTable">
                        <thead class="table-dark">
                            <tr>
                                <th>
                                    CategoriesId
                                </th>
                                <th>
                                    S/N
                                </th>
                                <th>
                                    CategoryName
                                </th>
                                <th>
                                    Edit
                                </th>
                                <th>
                                    Delete
                                </th>

                            </tr>
                        </thead>
                        <tbody></tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</div>
<div id="userModal" class="modal fade">
    <div class="modal-dialog">
        <div class="modal-content" id="userModalBody">

        </div>
    </div>
</div>

<script type="text/javascript">

     function updateModal(userId) {
        $.get('@Url.Action("UpdateQCategory", "Question")', { Id: userId }, function (res) {
            $("#userModalBody").html(res);
            $("#userModal").modal("show");
           // oTable.ajax.reload();
        });
    }	
     function deleteModal(userId) {
        $.get('@Url.Action("DeleteQCategory", "Question")', { Id: userId }, function (res) {
            $("#userModalBody").html(res);
            $("#userModal").modal("show");
           // oTable.ajax.reload();
        });
    }
    var oTable;
    $(document).ready(function () {
        //  debugger;     
        toastrFunction();
         oTable = $("#myTable").DataTable({
            "processing": true, // for show progress bar
            "serverSide": true, // for process server side
            "filter": true, // this is for disable filter (search box)
            "orderMulti": false, // for disable multiple column at once
            columns: [
                { 'data': 'CategoryId', 'orderable': false, visible: false },
                 {'data':'S/N',  render: function (data, type, full, meta) {

                     console.log("type", type)
                     console.log("full", full)
                     console.log("meta", meta.settings._iDisplayLength)
					 
					  console.log("_iDisplayStart", meta.settings._iDisplayStart)
				
                        var result = meta.row +1 +(meta.settings._iDisplayStart);
                      
                     return result;
                 }
                 },
                { 'data': 'CategoriesName' },
                {
                    "data": "CategoryId", 'orderable': false, "width": "50px", "render": function (data) {
                        
                                    return '<button class="btn btn-primary btn-lg" style="min-height:2rem" onclick="updateModal(' + data+ ')">Edit</button>';
                //        return '<a class="popup" href="@Url.Action("UpdateQCategory","Question")/' + data + '">Edit</a>';   
                    }
                },
                {
                    "data": "CategoryId", 'orderable': false,"width": "50px", "render": function (data) {
                        
                                    return '<button class="btn btn-danger btn-lg" style="min-height:2rem" onclick="deleteModal(' + data+ ')">Delete</button>';
               
                        //  return '<a class="popup" href="@Url.Action("DeleteQCategory", "Question")/' + data + '">Delete</a>';
                    }
                }
            ],
            "delay": 150,
            "ajax": {
                "url": "@Url.Action("GetAllQuestionCategories", "Question")", 
                "type": "POST",
                "datatype": "json"
            }
        })
       
		
   
    });

     function updateRecord() {
                    var form = $('form[name="updateCategoryForm"]');
         var entry = form.serialize();
         $.post('@Url.Action("DeleteQCategory", "Question")', entry, function (res) {  
            if (res.status) {
                toastr.success("Successfully Updated", "Notification");

                oTable.ajax.reload();
                $("#userModal").modal('hide');
            }
            else {
                toastr.error("Failed to update, <br> Please check if the record already existed", "Error Notification");
            }
           //
        });
    }
         function deleteRecord() {
                    var form = $('form[name="deleteCategoryForm"]');
         var entry = form.serialize();
         $.post('@Url.Action("DeleteQCategory", "Question")', entry, function (res) {  
            if (res.status) {
                toastr.success("Successfully Delete", "Notification");

                oTable.ajax.reload();
                $("#userModal").modal('hide');
            }
            else {
                toastr.error("Failed to update, <br> Please check your internet connnection", "Error Notification");
            }
           //
        });
    }

     function toastrFunction() {

         if ('@TempData["CreateCat"]'.length > 1) {
          toastr.success('@TempData["CreateCat"]','Notification');
         }
         else  if ('@TempData["Failed"]'.length>1) {
          toastr.error('@TempData["Failed"]','Notification');
       }

    }
</script>
